=== removed file 'drizzled/function/math/rand.cc'
--- drizzled/function/math/rand.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/math/rand.cc	1970-01-01 00:00:00 +0000
@@ -1,92 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-#include <drizzled/function/math/rand.h>
-#include <drizzled/session.h>
-
-namespace drizzled
-{
-
-static uint32_t sql_rnd()
-{
-  return (uint32_t) (rand() * 0xffffffff); /* make all bits random */
-}
-
-
-void Item_func_rand::seed_random(Item *arg)
-{
-  /*
-    TODO: do not do reinit 'rand' for every execute of PS/SP if
-    args[0] is a constant.
-  */
-  uint64_t tmp= (uint64_t) arg->val_int();
-  _seed_random_int(tmp * 0x10001L + 55555555L, tmp * 0x10000001L);
-}
-
-void Item_func_rand::_seed_random_int(uint64_t new_seed1, uint64_t new_seed2)
-{
-  max_value= 0x3FFFFFFFL;
-  max_value_dbl=(double) max_value;
-  seed1= new_seed1 % max_value;
-  seed2= new_seed2 % max_value;
-}
-
-bool Item_func_rand::fix_fields(Session *session,Item **ref)
-{
-  if (Item_real_func::fix_fields(session, ref))
-    return true;
-
-  used_tables_cache|= RAND_TABLE_BIT;
-  if (arg_count)
-  {                                     // Only use argument once in query
-    /*
-      No need to send a Rand log event if seed was given eg: RAND(seed),
-      as it will be replicated in the query as such.
-    */
-    if (args[0]->const_item())
-      seed_random(args[0]);
-  }
-  else
-  {
-    uint64_t tmp= sql_rnd();
-    _seed_random_int(tmp + (uint64_t) ref, tmp + (uint64_t) session->thread_id);
-  }
-
-  return false;
-}
-
-void Item_func_rand::update_used_tables()
-{
-  Item_real_func::update_used_tables();
-  used_tables_cache|= RAND_TABLE_BIT;
-}
-
-double Item_func_rand::val_real()
-{
-  assert(fixed == 1);
-  if (arg_count && !args[0]->const_item())
-    seed_random(args[0]);
-
-  seed1= (seed1 * 3 + seed2) % max_value;
-  seed2= (seed1 + seed2 + 33) % max_value;
-  return (((double) seed1) / max_value_dbl);
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/function/math/rand.h'
--- drizzled/function/math/rand.h	2010-02-04 08:14:46 +0000
+++ drizzled/function/math/rand.h	1970-01-01 00:00:00 +0000
@@ -1,51 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_MATH_RAND_H
-#define DRIZZLED_FUNCTION_MATH_RAND_H
-
-#include <drizzled/function/func.h>
-#include <drizzled/function/math/real.h>
-
-namespace drizzled
-{
-
-class Item_func_rand :public Item_real_func
-{
-  uint64_t seed1;
-  uint64_t seed2;
-  uint64_t max_value;
-  double max_value_dbl;
-  void _seed_random_int(uint64_t new_seed1, uint64_t new_seed2);
-
-public:
-  Item_func_rand(Item *a) :Item_real_func(a) {}
-  Item_func_rand()        :Item_real_func() {}
-  double val_real();
-  const char *func_name() const { return "rand"; }
-  bool const_item() const { return 0; }
-  void update_used_tables();
-  bool fix_fields(Session *session, Item **ref);
-private:
-  void seed_random (Item * val);
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_FUNCTION_MATH_RAND_H */

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-05-24 17:43:22 +0000
+++ drizzled/include.am	2010-06-04 09:05:44 +0000
@@ -121,7 +121,6 @@
 			      drizzled/function/math/ord.h \
 			      drizzled/function/math/plus.h \
 			      drizzled/function/math/pow.h \
-			      drizzled/function/math/rand.h \
 			      drizzled/function/math/real.h \
 			      drizzled/function/math/round.h \
 			      drizzled/function/math/sin.h \
@@ -536,7 +535,6 @@
 				 drizzled/function/math/ord.cc \
 				 drizzled/function/math/plus.cc \
 				 drizzled/function/math/pow.cc \
-				 drizzled/function/math/rand.cc \
 				 drizzled/function/math/real.cc \
 				 drizzled/function/math/round.cc \
 				 drizzled/function/math/sin.cc \
@@ -778,7 +776,6 @@
 
 sbin_PROGRAMS+= drizzled/drizzled
 
-
 noinst_LTLIBRARIES+= \
 		     drizzled/libcached_directory.la \
 		     drizzled/libcharset.la \

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2010-02-19 07:27:21 +0000
+++ drizzled/item/create.cc	2010-03-18 12:01:34 +0000
@@ -89,7 +89,6 @@
 #include <drizzled/function/numhybrid.h>
 #include <drizzled/function/math/ord.h>
 #include <drizzled/function/math/pow.h>
-#include <drizzled/function/math/rand.h>
 #include <drizzled/function/math/real.h>
 #include <drizzled/function/row_count.h>
 #include <drizzled/function/set_user_var.h>
@@ -1114,19 +1113,6 @@
 };
 
 
-class Create_func_rand : public Create_native_func
-{
-public:
-  virtual Item *create_native(Session *session, LEX_STRING name, List<Item> *item_list);
-
-  static Create_func_rand s_singleton;
-
-protected:
-  Create_func_rand() {}
-  virtual ~Create_func_rand() {}
-};
-
-
 class Create_func_round : public Create_native_func
 {
 public:
@@ -2334,42 +2320,6 @@
                                              M_PI/180, 0.0);
 }
 
-
-Create_func_rand Create_func_rand::s_singleton;
-
-Item*
-Create_func_rand::create_native(Session *session, LEX_STRING name,
-                                List<Item> *item_list)
-{
-  Item *func= NULL;
-  int arg_count= 0;
-
-  if (item_list != NULL)
-    arg_count= item_list->elements;
-
-  switch (arg_count) {
-  case 0:
-  {
-    func= new (session->mem_root) Item_func_rand();
-    break;
-  }
-  case 1:
-  {
-    Item *param_1= item_list->pop();
-    func= new (session->mem_root) Item_func_rand(param_1);
-    break;
-  }
-  default:
-  {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
-    break;
-  }
-  }
-
-  return func;
-}
-
-
 Create_func_round Create_func_round::s_singleton;
 
 Item*
@@ -2654,7 +2604,6 @@
   { { C_STRING_WITH_LEN("POWER") }, BUILDER(Create_func_pow)},
   { { C_STRING_WITH_LEN("QUOTE") }, BUILDER(Create_func_quote)},
   { { C_STRING_WITH_LEN("RADIANS") }, BUILDER(Create_func_radians)},
-  { { C_STRING_WITH_LEN("RAND") }, BUILDER(Create_func_rand)},
   { { C_STRING_WITH_LEN("ROUND") }, BUILDER(Create_func_round)},
   { { C_STRING_WITH_LEN("ROW_COUNT") }, BUILDER(Create_func_row_count)},
   { { C_STRING_WITH_LEN("RPAD") }, BUILDER(Create_func_rpad)},

=== added directory 'plugin/rand_function'
=== added file 'plugin/rand_function/plugin.ini'
--- plugin/rand_function/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/rand_function/plugin.ini	2010-03-18 12:01:34 +0000
@@ -0,0 +1,4 @@
+[plugin]
+title=RAND() function
+description=Function for pseudo-random number generation
+load_by_default=yes

=== added file 'plugin/rand_function/rand_function.cc'
--- plugin/rand_function/rand_function.cc	1970-01-01 00:00:00 +0000
+++ plugin/rand_function/rand_function.cc	2010-06-04 09:05:44 +0000
@@ -0,0 +1,129 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *  Copyright (C) 2010 Stewart Smith
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+#include <drizzled/plugin/function.h>
+#include <drizzled/item/func.h>
+#include <drizzled/function/math/real.h>
+#include <drizzled/session.h>
+
+using namespace std;
+using namespace drizzled;
+
+class RandFunction :public Item_real_func
+{
+  uint64_t seed1;
+  uint64_t seed2;
+  uint64_t max_value;
+  double max_value_dbl;
+  void _seed_random_int(uint64_t new_seed1, uint64_t new_seed2);
+
+public:
+  RandFunction()        :Item_real_func() {}
+  double val_real();
+  const char *func_name() const { return "rand"; }
+  bool const_item() const { return 0; }
+  void update_used_tables();
+  bool fix_fields(Session *session, Item **ref);
+
+  bool check_argument_count(int n)
+  {
+    return (n == 0 || n == 1);
+  }
+
+private:
+  void seed_random (Item * val);
+};
+
+static uint32_t sql_rnd()
+{
+  return (uint32_t) (rand() * 0xffffffff); /* make all bits random */
+}
+
+
+void RandFunction::seed_random(Item *arg)
+{
+  /*
+    TODO: do not do reinit 'rand' for every execute of PS/SP if
+    args[0] is a constant.
+  */
+  uint64_t tmp= (uint64_t) arg->val_int();
+  _seed_random_int(tmp * 0x10001L + 55555555L, tmp * 0x10000001L);
+}
+
+void RandFunction::_seed_random_int(uint64_t new_seed1, uint64_t new_seed2)
+{
+  max_value= 0x3FFFFFFFL;
+  max_value_dbl=(double) max_value;
+  seed1= new_seed1 % max_value;
+  seed2= new_seed2 % max_value;
+}
+
+bool RandFunction::fix_fields(Session *session,Item **ref)
+{
+  if (Item_real_func::fix_fields(session, ref))
+    return true;
+
+  used_tables_cache|= RAND_TABLE_BIT;
+  if (arg_count)
+  {                                     // Only use argument once in query
+    /*
+      No need to send a Rand log event if seed was given eg: RAND(seed),
+      as it will be replicated in the query as such.
+    */
+    if (args[0]->const_item())
+      seed_random(args[0]);
+  }
+  else
+  {
+    uint64_t tmp= sql_rnd();
+    _seed_random_int(tmp + (uint64_t) ref, tmp + (uint64_t) session->thread_id);
+  }
+
+  return false;
+}
+
+void RandFunction::update_used_tables()
+{
+  Item_real_func::update_used_tables();
+  used_tables_cache|= RAND_TABLE_BIT;
+}
+
+double RandFunction::val_real()
+{
+  assert(fixed == 1);
+  if (arg_count && !args[0]->const_item())
+    seed_random(args[0]);
+
+  seed1= (seed1 * 3 + seed2) % max_value;
+  seed2= (seed1 + seed2 + 33) % max_value;
+  return (((double) seed1) / max_value_dbl);
+}
+
+plugin::Create_function<RandFunction> *rand_function= NULL;
+
+static int initialize(module::Context &registry)
+{
+  rand_function= new plugin::Create_function<RandFunction>("rand");
+  registry.add(rand_function);
+  return 0;
+}
+
+DRIZZLE_PLUGIN(initialize, NULL);

=== added directory 'plugin/rand_function/tests'
=== added directory 'plugin/rand_function/tests/r'
=== added file 'plugin/rand_function/tests/r/basic.result'
--- plugin/rand_function/tests/r/basic.result	1970-01-01 00:00:00 +0000
+++ plugin/rand_function/tests/r/basic.result	2010-06-04 09:14:27 +0000
@@ -0,0 +1,7 @@
+explain extended select rand(999999),rand();
+id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
+1	SIMPLE	NULL	NULL	NULL	NULL	NULL	NULL	NULL	NULL	No tables used
+Warnings:
+Note	1003	select rand(999999) AS `rand(999999)`,rand() AS `rand()`
+select rand(rand);
+ERROR 42S22: Unknown column 'rand' in 'field list'

=== added directory 'plugin/rand_function/tests/t'
=== added file 'plugin/rand_function/tests/t/basic.test'
--- plugin/rand_function/tests/t/basic.test	1970-01-01 00:00:00 +0000
+++ plugin/rand_function/tests/t/basic.test	2010-06-04 09:14:27 +0000
@@ -0,0 +1,8 @@
+explain extended select rand(999999),rand();
+#
+# Bug #7281: problem with rand()
+#
+
+--error 1054
+select rand(rand);
+

=== modified file 'tests/r/func_math.result'
--- tests/r/func_math.result	2009-08-05 05:54:47 +0000
+++ tests/r/func_math.result	2010-06-04 09:14:27 +0000
@@ -95,11 +95,6 @@
 1	SIMPLE	NULL	NULL	NULL	NULL	NULL	NULL	NULL	NULL	No tables used
 Warnings:
 Note	1003	select pow(10,log10(10)) AS `pow(10,log10(10))`,pow(2,4) AS `power(2,4)`
-explain extended select rand(999999),rand();
-id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	SIMPLE	NULL	NULL	NULL	NULL	NULL	NULL	NULL	NULL	No tables used
-Warnings:
-Note	1003	select rand(999999) AS `rand(999999)`,rand() AS `rand()`
 select pi(),format(sin(pi()/2),6),format(cos(pi()/2),6),format(abs(tan(pi())),6),format(cot(1),6),format(asin(1),6),format(acos(0),6),format(atan(1),6);
 pi()	format(sin(pi()/2),6)	format(cos(pi()/2),6)	format(abs(tan(pi())),6)	format(cot(1),6)	format(asin(1),6)	format(acos(0),6)	format(atan(1),6)
 3.141593	1.000000	0.000000	0.000000	0.642093	1.570796	1.570796	0.785398
@@ -149,8 +144,6 @@
 1	SIMPLE	NULL	NULL	NULL	NULL	NULL	NULL	NULL	NULL	No tables used
 Warnings:
 Note	1003	select degrees(pi()) AS `degrees(pi())`,radians(360) AS `radians(360)`
-select rand(rand);
-ERROR 42S22: Unknown column 'rand' in 'field list'
 create table t1 (col1 int, col2 decimal(60,30));
 insert into t1 values(1,1234567890.12345);
 select format(col2,7) from t1;

=== modified file 'tests/t/func_math.test'
--- tests/t/func_math.test	2009-06-16 00:53:22 +0000
+++ tests/t/func_math.test	2010-06-04 09:14:27 +0000
@@ -27,7 +27,6 @@
 explain extended select log10(100),log10(18),log10(-4),log10(0),log10(NULL);
 select pow(10,log10(10)),power(2,4);
 explain extended select pow(10,log10(10)),power(2,4);
-explain extended select rand(999999),rand();
 select pi(),format(sin(pi()/2),6),format(cos(pi()/2),6),format(abs(tan(pi())),6),format(cot(1),6),format(asin(1),6),format(acos(0),6),format(atan(1),6);
 explain extended select pi(),format(sin(pi()/2),6),format(cos(pi()/2),6),format(abs(tan(pi())),6),format(cot(1),6),format(asin(1),6),format(acos(0),6),format(atan(1),6);
 select degrees(pi()),radians(360);
@@ -64,13 +63,6 @@
 
 explain extended select degrees(pi()),radians(360);
 
-#
-# Bug #7281: problem with rand()
-#
-
---error 1054
-select rand(rand);
-
 # End of 4.1 tests
 
 #

